/*
* Copyright (c) 2005-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
 *
 * Description: 
 *
*/


// This contains CT_DataSIPNotifyDialogAssoc

#ifndef __T_SIPNOTIFYDIALOGASSOC__
#define __T_SIPNOTIFYDIALOGASSOC__



#include "t_csipdialogassocbase.h" 

#include <sipnotifydialogassoc.h>

class CT_DataSIPNotifyDialogAssoc : public CT_DataSIPDialogAssocBase
	{
public:
    static CT_DataSIPNotifyDialogAssoc* NewL();
    ~CT_DataSIPNotifyDialogAssoc();
    
    virtual TBool   DoCommandL(const TTEFFunction& aCommand, const TTEFSectionName& aSection, const TInt aAsyncErrorIndex);
    virtual TAny*   GetObject();
    virtual void    SetObjectL(TAny* aAny);
    virtual void    DisownObjectL();
    void            SetIsOwner(TBool aIsOwner);
    
protected:
    CT_DataSIPNotifyDialogAssoc();
    void ConstructL();
    virtual CSIPDialogAssocBase* GetSIPDialogAssocBase() const; 
    
private:
	void DoCmdNewL(const TTEFSectionName& aSection);
	void DoCmdNewLC(const TTEFSectionName& aSection);
	void DoCmdEvent(const TTEFSectionName& aSection);
	void DoCmdSendNotifyL(const TTEFSectionName& aSection);
    void DoCmdSubscriptionState(const TTEFSectionName& aSection);
	void DoCmdDestructor(const TTEFSectionName& aSection);
    void DestroyData();

private:
    CSIPNotifyDialogAssoc* iSIPNotifyDialogAssoc;
    TBool                  iIsOwner;
	};

#endif /* __T_SIPNOTIFYDIALOGASSOC__ */

